//============================================================================//
//
//  Software Name : MEGADOCK Version 2.1
//
//  Class Name : CPUTime
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#include "cpu_time.h"

//============================================================================//
void CPUTime::initialize()
//============================================================================//
{
  control_initialize = 0.0;
  receptor_process = 0.0;
  docking_dock = 0.0;
  protein_lig_voxelization = 0.0;
  fftprocess_ligand_fft = 0.0;
  fftprocess_fftoutl = 0.0;
  fftprocess_fftinl = 0.0;
  fftprocess_fft_inverse = 0.0;
  fftprocess_score_sort = 0.0;
  fftprocess_sort_index = 0.0;
  docking_output = 0.0;

  return;
}

//============================================================================//
void CPUTime::output()
//============================================================================//
{
  
  cout << "\nCPU time (initialize)        = " << control_initialize << " sec.\n";
  cout << "CPU time (receptor process)   = " << receptor_process << " sec.\n";
  cout << "CPU time (docking)            = " << docking_dock << " sec.\n";
  cout << "  | Ligand voxelization       = " << protein_lig_voxelization << " sec.\n";
  cout << "  | Ligand FFT                = " << fftprocess_ligand_fft << " sec.\n";
  cout << "  | Output ligand FFT data    = " << fftprocess_fftoutl << " sec.\n";
  cout << "  | Input ligand FFT data     = " << fftprocess_fftinl << " sec.\n";
  cout << "  | Inverse FFT to get score  = " << fftprocess_fft_inverse << " sec.\n";
  cout << "  | Sort score (each core)    = " << fftprocess_score_sort << " sec.\n";
  cout << "  | Sort score (merge)        = " << fftprocess_sort_index << " sec.\n";
  cout << "CPU time (output)             = " << docking_output << " sec.\n";

  return;
}
