//============================================================================//
//
//  Software Name : MEGADOCK Version 2.1
//
//  Class Name : HeaderDB
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#ifndef HeaderDB_h
#define HeaderDB_h 1

#include "parameter.h"

using namespace std;

class HeaderDB						// FFT header file class
{
 private:
  //HeaderDB(HeaderDB &c){}				// Copy constructor
  //const HeaderDB & operator=(const HeaderDB &c){}	// Operator override	
  Parameter		*_parameter;
  int			_Num_fft;
  string		_PDB_file;
  float			_Center[3];
 public:
  HeaderDB(Parameter *pparameter) : _parameter(pparameter) {
#ifdef DEBUG
    cout << "Constructing HeaderDB.\n";
#endif
  }
  virtual ~HeaderDB() {					// Destructor
#ifdef DEBUG
    cout << "Destructing HeaderDB.\n";
#endif

  }
  virtual void		fft_read(const int &ilig);	// Read fft file
  virtual void 		fft_comm(const int &ip,const int &nproc,const int &myid);
  virtual int		num_fft() 		{ return _Num_fft; }
  virtual int		num_grid() 		{ return _Num_fft/2; }
  virtual string	pdb_file()		{ return _PDB_file; }
  virtual float		center(const int &i)	{ return _Center[i]; }
};

#endif
