//============================================================================//
//
//  Software Name : MEGADOCK Version 2.1
//
//  Class Name : Parallel
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#ifndef Parallel_h
#define Parallel_h 1

#include <stdlib.h>
#include <time.h>
#include <sys/time.h>

#ifdef PARALLEL
#include <mpi.h>
#endif

#ifdef _OPENMP
#include <omp.h>
#endif

class Parallel
{
private:
  Parallel(Parallel &c){}
  int		_Nproc;
  int		_Nproc2;
  int		_Myid;
public:
  Parallel(const int &nproc,const int &nproc2,const int &myid)
    : _Nproc(nproc),_Nproc2(nproc2),_Myid(myid) {
#ifdef DEBUG
    cout << "Constructing Parallel.\n";
#endif
  }
  virtual	~Parallel()		{
#ifdef DEBUG
    cout << "Destructing Parallel.\n";
#endif
  }
  void		nproc(int i)		{ _Nproc = i; }
  int		nproc()			{ return _Nproc; }
  void		nproc2(int i)		{ _Nproc2 = i; }
  int		nproc2()		{ return _Nproc2; }
  void		myid(int i)		{ _Myid = i; }
  int		myid()			{ return _Myid; }
};

#endif
