//============================================================================//
//
//  Software Name : MEGADOCK Version 2.1
//
//  Class Name : Receptor
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#ifndef Receptor_h
#define Receptor_h 1

#include "protein.h"
#include "parameter.h"

using namespace std;

class Receptor : public Protein		// Receptor class
{
 private:
  //  const Receptor & operator=(const Receptor &c);
 public:
  Receptor(string &rinput_file) : Protein(rinput_file) {
#ifdef DEBUG
    cout << "Constructing Receptor.\n";
#endif
  }
  virtual ~Receptor() {
#ifdef DEBUG
    cout << "Destructing Receptor.\n";
#endif
  }
  virtual void	katchalski(const int &score_func,const int &num_grid,
			   float *grid_coord,float *mol_coord,float *fwork);
  virtual void	gsc(const int &num_grid,float *grid_coord,float *mol_coord,
		    int *iwork,float *fwork);
  virtual void	psc(const int &num_grid,float *grid_coord,float *mol_coord,
		    int *iwork,float *fwork);
  virtual void	rpsc(const int &num_grid,float *grid_coord,float *mol_coord,
		     int *iwork,float *fwork);
  virtual void	electro(const float &beta,const float &eratio,
			const int &num_grid,float *grid_coord,float *mol_coord,
			int *iwork,float *fwork, float grid_size);
  virtual void 	precalc(const int &num_grid,int *nearesta,float *rjudge2,
			float *radius_core2,float *radius_surf2);
};

#endif
